<?php
	error_reporting(E_ERROR);
	
	$input = file_get_contents("php://stdin");
	$variables = parse_variables($input);
	$skip = array("args", "key", "display", "result", "alias", "aliases_found", "colwidth", "file", "fmt", "item", "new_val", "old_val", "text_cell", "text_row", "try", "dq_argi");
	$variables = array_filter($variables, function ($variable) {
		global $skip;
		$name = $variable["name"];
		if (substr($name, 0, 3) == "CR_") {
			return false;
		} else if (substr($name, 0, 4) == "_Dbg") {
			return false;
		} else if (substr($name, 0, 5) == "BASH_") {
			return false;
		} else if (in_array($name, $skip)) {
			return false;
		}
		return true;
	});
	$tmp_vars = getenv("CR_VARIABLES_TMP");
	if ($tmp_vars) {
		$initial_vars = json_decode($tmp_vars, true);
		if ($initial_vars && gettype($initial_vars) == 'array') {
			$variables = array_udiff($variables, $initial_vars, function ($a, $b) {
				return strcmp($a["name"], $b["name"]);
			});
		}
	}
	$variables = array_values($variables);
	usort($variables, function ($a, $b) {
		return strcmp($a["name"], $b["name"]);
	});
	echo json_encode($variables);
	
	function parse_variables($input) {
		$variables = array();
		while (preg_match('/^(?:[\n\r]*)(\S.*?)=/', $input, $matches, PREG_OFFSET_CAPTURE)) {
			$name = $matches[1][0];
			$loc = $matches[0][1]+strlen($matches[0][0]);
			$value = parse_value($input, $loc, $cutloc);
			if (gettype($value) == 'string' && strlen($value) > 1500) {
				$value = substr($value, 0, 1500)." [...]";
			}
			array_push($variables, array(
				"name" => $name,
				"value" => $value
			));
			$input = substr($input, $cutloc);
		}
		return $variables;
	}
	
	function parse_value($input, $loc, &$cutloc) {
		if ($loc == strlen($input)) return "";
		if ($input[$loc] == "'" || $input[$loc] == '"' || ($input[$loc] == "$" && $input[$loc+1] == "'")) {
			$dollarQuote = false;
			if ($input[$loc] == "$") {
				$dollarQuote = true;
				$loc += 1;
			}
			$escapeCount = 0;
			$i = $loc+1;
			for (; $i < strlen($input); $i++) {
				if ($input[$i] == $input[$loc] && $escapeCount % 2 == 0) {
					if ($input[$loc] == "'" && substr($input, $i, 4) == "'\\''") {
						$i += 3;
					} else {
						break;
					}
				} else if ($input[$i] == "\\" && ($input[$loc] != "'" || $dollarQuote)) {
					$escapeCount++;
				} else {
					$escapeCount = 0;
				}
			}
			$cutloc = $i+1;
			if ($dollarQuote) {
				$loc -= 1;
			}
			return substr($input, $loc, $i-$loc+1);
		} else if ($input[$loc] == "(") {
			$i = $loc+1;
			$array = array();
			$key = false;
			$bracket = false;
			for (; $i < strlen($input); $i++) {
				$c = $input[$i];
				if ($c == ' ' || $c == "\t" || $c == "\n" || $c == "\r") {
					continue;
				}
				if ($key === false) {
					if ($bracket === false) {
						if ($c == '[') {
							$bracket = $i;
						} else {
							break;
						}
					} else if ($bracket == $i-1) {
						if ($c == '"' || $c == "'" || ($c == "$" && $input[$i+1] == "'")) {
							$key = parse_value($input, $i, $cutloc);
							$i = $cutloc; // skip next char ']'
						}
					} else {
						if ($c == ']') {
							$key = substr($input, $bracket+1, $i-$bracket-1);
						}
					}
				} else {
					if ($c == '=') {
						$value = parse_value($input, $i+1, $cutloc);
					} else {
						$value = "";
						$cutloc = $i+1;
					}
					array_push($array, array(
						"name" => $key,
						"value" => $value
					));
					$i = $cutloc-1;
					$key = false;
					$bracket = false;
				}
			}
			$cutloc = $i+1;
			return $array;
		} else {
			$line_end = strlen($input);
			$i = $loc;
			for (; $i < $line_end; $i++) {
				if ($input[$i] == "\r" || $input[$i] == "\n") {
					break;
				}
			}
			$cutloc = $i;
			return substr($input, $loc, $i-$loc);
		}
	}
?>